<!--
*  MyDBDB Version 1.01
*  8/18/2007
*  Don Ravey - ravey@alum.mit.edu
*
*  Changes:
*
*  1.01:  Enable Submit Query button only when a table has been selected.
-->
<?php
	require ("dbdata.inc");
?>
<html>
<head>
<title>MySQL Database Manager</title>
<style type="text/css">
	body	{ font-family:sans-serif; font-size:9pt; }
	table.a	{ width:96%; background-color:#6060ff; }
	td		{ background-color:white; border:solid #c0c0c0 2px; font-size:9pt;
			vertical-align:top; padding:4px; font-size:9pt; color:blue; }
	td.hdr	{ color:#ffe990; font-size:11pt; font-weight:bold; text-align:center; padding:0;
			width:100%; height:24px; background-image:url("bg2.gif"); background-repeat:horizontal;
			border:none; vertical-align:middle; }
	.query	{ font-weight:bold; color:green; cursor:pointer; cursor:hand; }
	.sm		{ font-size:7pt; color:green; }
	.big	{ font-size:12pt; font-weight:bold; }
</style>
<script type="text/javascript">
<!-- 
function makeARO () {
	var ajaxRequest;
	var pwd2 = document.getElementById("pwd2").value;
	try{
		ajaxRequest = new XMLHttpRequest();
	} catch (e){
		try{
			ajaxRequest = new ActiveXObject("Msxml2.XMLHTTP");
		} catch (e) {
			try{
				ajaxRequest = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (e){
				alert("Your browser broke!");
				return false;
			}
		}
	}
	return ajaxRequest;
}

function filltables () {
	var ajaxRequest;
	var pwd2 = document.getElementById("pwd2").value;
	var sel = document.getElementById("server").value;
	var tbls;
	var ver;
	if (sel > 0) {
		ajaxRequest = makeARO();
		ajaxRequest.onreadystatechange = function(){
			if(ajaxRequest.readyState == 4){
				tbls = ajaxRequest.responseText.split("|")[0];
				ver = ajaxRequest.responseText.split("|")[1];
				document.getElementById("tables").innerHTML = tbls;
				document.getElementById("ver").innerHTML = ver;
			}
		}
		ajaxRequest.open("GET", "getTables.php?idx="+sel+"&pwd2="+pwd2, true);
		ajaxRequest.send(null);
	} 
	/* Disable the Submit Query button when new table is selected */
	document.getElementById("submit").style.visibility = "hidden";
}

function insertfields(fieldstring) {
	var i;
	var pffarray = fieldstring.split(",");
	var len = pffarray.length - 1;
	var len2 = Math.min(len, 6);
	var tbl = document.getElementById("tableselected").value;
	var recs = pffarray[0];
	/* Format the fields list */
	var fields = "<div style='text-align:left;'><u>FIELDS in " + tbl + ":</u><br />";
	for (i=1; i<=len; i++) {
		fields = fields + pffarray[i] + "<br />";
	}
	fields = fields + "--------------<br />No. of records: " + recs + "</div>";
	document.getElementById("fieldlist").innerHTML = fields;
	/* Format the proforma SQL */
	var sql = "SELECT ";
		for (i=1; i<=len2; i++){
		sql = sql + pffarray[i] + ",";
		}
	sql = sql.substring(0, sql.length - 1);
	sql = sql + " FROM " + tbl + " WHERE 1=1 ORDER BY " + pffarray[1];
	document.getElementById("usersqlarea").value = sql;
	/* Enable the Submit Query button */
	document.getElementById("submit").style.visibility = "visible";
}

function listfields () {
	var ajaxRequest;
	var table;
	var sel = document.getElementById("server").value;
	if (sel > 0) {
		ajaxRequest = makeARO();
	/* Set object function to update Field List */
		ajaxRequest.onreadystatechange = function(){
			if(ajaxRequest.readyState == 4){
				insertfields(ajaxRequest.responseText);
			}
		}
		sel=document.getElementById("server").value;
		table=document.getElementById("tableselected").value;
		ajaxRequest.open("GET", "getFields.php?idx="+sel+"&table="+table, true);
		ajaxRequest.send(null);
	}
}

function submitQuery(pg,rpp) {
	var usersql, usersqlu;
	var sel, rpp;
	if ((document.getElementById("server").value == " Select a host --") ||
		(document.getElementById("tableselected").value == "<--Select server first")) {
			document.getElementById("usersqlarea").innerHTML = "You must select a server and a table!";
			return;
	}
	rpp = document.getElementById("rpp").value;
	usersql=document.getElementById("usersqlarea").value;
	usersqlu=usersql.toUpperCase();
	if (usersqlu.indexOf("DELETE")>0 || usersqlu.indexOf("UPDATE")>0 || usersqlu.indexOf("DROP")>0) {
		document.getElementById("usersqlarea").value="DELETE or UPDATE queries not currently supported";
		return;
	}
	if (usersql.indexOf("LIMIT")>0) {
		usersql = LEFT(usersql, usersql.indexOf("LIMIT") - 1);
	}
	ajaxRequest = makeARO();
	ajaxRequest.onreadystatechange = function(){
		if(ajaxRequest.readyState == 4){
			document.getElementById("results").innerHTML = ajaxRequest.responseText;
		}
	}
	sel=document.getElementById("server").value;
	if (pg=='') {
		ajaxRequest.open("GET", "runQuery.php?q="+usersql+"&idx="+sel+"&rpp="+rpp, true);
	} else {
		ajaxRequest.open("GET", "runQuery.php?q="+usersql+"&idx="+sel+"&rpp="+rpp+"&pg="+pg, true);
	}
	ajaxRequest.send(null);
}
//-->
</script>
</head>

<body onLoad="document.serverselect.pwd2.focus();">

<table class="a" align="center">
  <tr>
    <td colspan="9" class="hdr">
		<?php echo $dbdbname ?>
	</td>
  </tr>
  <tr>
  	<td colspan="2" style="text-align:center; width:40%;">
	<FORM name="serverselect" method="post">
		<!--  1  -->
		<span class="big">1. </span>&nbsp; Enter your password: <input type="password" id="pwd2" size="8" /><br />
		<span class="sm">Do NOT press Enter, just move to Server selection</span>
	</td>
	<td style="text-align:center; width:30%; height:24px;">
		<!--  2  -->
		<span class="big">2. </span>&nbsp; Select a MySQL Server:
<?php
	$dbs = count($databases);
	$servers = array("Select a host --");
	for ($i==1; $i<=$dbs; $i++) {
		$servers[$i] = $databases[$i][0];
	}
	echo '<SELECT id="server" onChange="filltables();" onClick="filltables();">';
	for ($i=0; $i<8; $i++) {
		echo "<option value=$i";
		if ($i==0) echo " SELECTED";
		echo ">".$servers[$i]."</option>";
	}
?>
	</select>
	<br /><span id="ver" class="sm">
	<!-- To be filled in by Ajax request -->
	</span> 
	</td>
	<td style="text-align:center; width:30%; height:24px;">
		<!--  3  -->
		<span class="big">3. </span>&nbsp; Select a MySQL Table:
		<span id="tables"><select id="tableselected"><option selected>&lt;--Select server first
		<!-- To be filled in by Ajax request -->
		</option></select></span><br />
		<span class="sm">CLICK on the table you want to select</span>
	</FORM>
	</td>
  </tr>
  <tr>
  	<td rowspan="2" id="fieldlist" style="width:18%; height:520px; padding-left:6px;">Fields:<br />
  	<!-- To be filled in by Ajax request -->	
	</td>
	<td id="sqlstr" colspan="3" style="text-align:left;">&nbsp; &nbsp; <strong>Edit SQL:</strong> 
		&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; Rows per page: 
		<SELECT id="rpp"><option value=10>10</option><option value=20 selected>20</option>
		<option value=30>30</option><option value=50>50</option></SELECT>
		&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
		<input type="button" id="submit" value="Submit Query" onClick="submitQuery();" 
			style="color:green; visibility:hidden;" />
		<textarea id="usersqlarea" rows="3" cols="84"> 
		An editable pro forma SQL query will appear here</textarea>
	</td>
  <tr>
	<td id="results" colspan="3" style="height:420px;"> Here's where your results will appear
	<!-- To be filled in by Ajax request -->
	</td>
  </tr>
</table>
</body>
</html>

